#ifndef __ANALYSE_H__
#define __ANALYSE_H__




// Librairies

#include "minus.h"


// Prototype

int AnalyseLigne(char * capt);


//variables

static int scapt[];

//------------------------------------------------------------------------------------
// AnalyseLigne 
// Retourne le barycentre si tout se passe bien [-248 : +248]
	// -248 :  fond  gauche
	// 248  :  fond  droite
// Retourne 250 si tous les capteurs sont teint
// Retourne 251 si dtection d'une priorit
// Retourne 252 si dtection d'un raccourcie

int AnalyseLigne(char * capt)
{


	int num,denom;
	unsigned char i;
	long int barycentre;
	int	LookUpTable[32]={-248,-232,-216,-200,-184,-168,-152,-136,-120,-104,-88,-72,-56,-40,-24,-8,8,24,40,56,72,88,104,120,136,152,168,184,200,216,232,248};

	num=0;
	denom=0;
	
	for(i=0;i<32;i++)
	{
		
		if(capt[i]) num-=LookUpTable[i];	//somme des coefficients des capteurs allums
		denom += capt[i];					//nombre de capteurs aligns
		scapt[i]=capt[i];		
	}

	barycentre = (int)((float)num/(float)denom);


	// Aucun capteur n'est allum : plus de ligne ???
	if (denom==0) return (250);

	if (denom>5 && denom<21)//dtection ligne priorit ou raccourcie
	{
		if(barycentre>0)
		{

			return	251;
		}
		else
		{		
			return 252;
		}

	}
	
	//on retourne le barycentre

	return (barycentre);
}


#endif
