// Librairies

#include <math.h>
#include <usart.h>
#include <p18f452.h>
#include "ConfigPorts.h"
#include "minus.h"
#include "AnalyseLigne.h"
#include "control.h"
#include "RS232.h"
// Dfinitions

#define Kv 5

// variables globales


int Pos; 				// Position de la ligne sous les capteurs


int Vmoy=220;

int cpt=0;
int i=0;


int MoteurG=0;		// Commande des moteurs
int MoteurD=0;

long int Distance=0;

int flagPrioriteIR1=0;
int flagPrioriteIR2=0;
int flagPrioriteIR3=0;
int flagDevantIR=0;


int State=0;

// Prototype des fonctions

void InterruptVectorLow (void);		// Vecteur de redirection des IT
void RoutineInterrupt(void);		// Gestionnaire de rpartition des IT
void InterruptEch(void);			// Routine principale d'interruption
int Suivi(void);


#pragma code InterruptVectorLow = 0x08				// Place le code  l'adresse 0x08
void InterruptVectorLow (void)						// Redirection de l'interruption ...
{
  _asm   goto RoutineInterrupt _endasm				// ... vers la fonction Routineinterrupt
}
#pragma code										// Retourne  la section par dfaut



// Routine d'interruption

#pragma interrupt RoutineInterrupt							// Spcifie qu'il s'agit de la routine d'interruption
void RoutineInterrupt ()										// Routine d'interruption
{
 	if(PIR2bits.TMR3IF)								// Vrifie qu'il s'agit bien de l'interruption du Timer 3
	{	
		WriteTimer3(T_TIMER3);						// Recharge le compteur du Timer 3
		InterruptEch();
		CB_RB3=!CB_RB3;
		PIR2bits.TMR3IF=0;							// Timer3 Interrupt Flag = 0 Baisse le flag du timer 3
	}

}
#pragma code

//------------------------------------------------------------------------------------	
void InterruptEch(void)
{
	// Variables

	int codeurD;
	int codeurG;


	int SpeedG;			// Erreur (Epsilon)
	int SpeedD;
	static int Tempo=0;


	// ------------ ENTREES ---------------

	// Lecture des entres


	codeurD=ReadTimer1();
	codeurG=ReadTimer0();



	// ------------ TRAITEMENT ---------------


    SpeedG=CalculeVitesseG(codeurG);
	SpeedD=CalculeVitesseD(codeurD);


	// Machine  tat

	switch (State)
	{
		case 0 : 	MoteurD=0; 				// Attends que le Jack soit mis
					MoteurG=0;
					if (Jack) Tempo++; else Tempo=0;//pour l'antirebond
					if (Tempo>10)
					{
					 	Tempo=0;
						State=10;	 

					}
					break;

		case 10 : 	MoteurD=0; 				// Attends que le Jack soit retir pour dmarrer
					MoteurG=0;
					if (!Jack) State=20;	
					break;

		case 20 : 			 			// Dpart en aveugle, on avance tout droit jusu' la ligne
					MoteurG=PI_gauche(200,SpeedG);
					MoteurD=PI_droit (200,SpeedD);
					if (Pos<249) State=30; 
					break;

		case 30: 							// On suit la ligne normalement



					if (Pos<249)		
					{
						MoteurG=Vmoy + Kv*Pos;
						MoteurD=Vmoy - Kv*Pos;
						break;
					}
					switch (Pos)
					{
						case 250:			//tous les capteurs sont teint
									State=150;
									break;
						case 251: 			//	dtection d'une priorit
									State=40;	
									break;
						case 252: 			//dtection d'un raccourci
									State=30;
									break;
					}

	 
					break;

		case 40:
					MoteurG=Vmoy + Kv*Pos;
					MoteurD=Vmoy - Kv*Pos;
					if(Pos!=251) State=41;
					break;
		case 41:
					Distance+=fabs(SpeedD)+fabs(SpeedG);
					if(Distance>3062*2)//10 cm
					{
						Distance=0;
						State=30;
					}
					if(Pos==251) 
					{
						Distance=0;
						State=110;
					}
					break;

		case 110:

					MoteurG=(220);
					MoteurD=(-220);
					Distance+=SpeedG-SpeedD;
					if(Distance>25500)
					{
						Distance=0;
						State=30;
						
					}
					break;

		case 150:

					MoteurG=0;
					MoteurD=0;
					break;




	}


				

	// ------------ SORTIES ---------------

	// Met les sorties  jour 

	CommandeMoteurG(MoteurG);
	CommandeMoteurD(MoteurD);
}




